-----------------------------------------------------------------------------------------------------------------------------------------
-- Entity Name:  LargeSelfAddrFifo_TestBench
-- File Name:    LargeSelfAddrFifo_TestBench.vhd
-- File Path:    E:\Projects\LargeSelfAddrFifo\Vhdl\
-- Project :
--
-- TESTBENCH, DON'T USE THIS FILE FOR COMPILATION !
-- Purpose: 
--
-- Limitations: none
--
-- Authors: Marc Defossez
--
-- Tools: 
--
--  Contact:    e-mail  hotline@xilinx.com        phone   + 1 800 255 7778
--
--  Disclaimer:
--              LIMITED WARRANTY AND DISCLAMER.
--              These designs are provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied, statutory or otherwise, and
--              Xilinx specifically disclaims any implied warranties of merchantability, non-infringement,
--              or fitness for a particular purpose. Xilinx does not warrant that the functions contained
--              in these designs will meet your requirements, or that the operation of these designs will
--              be uninterrupted or error free, or that defects in the designs will be corrected.
--              Furthermore, Xilinx does not warrant or make any representations regarding use or the
--              results of the use of the designs in terms of correctness, accuracy, reliability, or otherwise.
--
--              LIMITATION OF LIABILITY.
--              In no event will Xilinx or its licensors be liable for any loss of data, lost profits, cost or
--              procurement of substitute goods or services, or for any special, incidental, consequential,
--              or indirect damages arising from the use or operation of the designs or accompanying
--              documentation, however caused and on any theory of liability. This limitation will apply
--              even if Xilinx has been advised of the possibility of such damage. This limitation shall
--              apply not-withstanding the failure of the essential purpose of any limited remedies herein.
--
--              Copyright  2002 Xilinx, Inc.
--              All rights reserved
--
-- Revision History:       Created:       08/03/04
--                         Last opened:   Monday,Mar 08 04
--                                        12:57:39
--
----------------------------------------------------------------------------------------------------------------------------------------
--
library IEEE ;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;
use STD.textio.all;

entity LargeSelfAddrFifo_TestBench is
-- Declarations
end LargeSelfAddrFifo_TestBench ;

architecture LargeSelfAddrFifo_struct of LargeSelfAddrFifo_TestBench is

-- Architecture declarations

-- Internal signal declarations
signal SimClkPortA	: std_logic;
signal SimRstPortA	: std_logic;
signal SimEnaPortA	: std_logic;
signal SimWrePortA	: std_logic;
signal SimDatInPortA	: std_logic_vector (31 downto 0);
signal SimEmpty		:  std_logic;
signal SimFull		:  std_logic;
signal SimHalf		:  std_logic;
signal SimClkPortB	: std_logic;
signal SimRstPortB	: std_logic;
signal SimEnaPortB	: std_logic;
signal SimDatOutportB	:  std_logic_vector (31 downto 0);

-- Component Declarations
component LargeSelfAddrFifo
    port (
        ClkPortA	: in std_logic;
        RstPortA	: in std_logic;
        EnaPortA	: in std_logic;
        WrePortA	: in std_logic;
        DatInPortA	: in std_logic_vector (31 downto 0);
        FlagE		: out std_logic;	-- Empty flag. Fifo between empty and 1/4.
        FlagEh		: out std_logic;	-- Empty-Half flag. Fifo between 1/4 and half.
        FlagHf		: out std_logic;	-- Half-Full flag. Fifo between half and 3/4.
        FlagF		: out std_logic;	-- Full flag. Fifo between 3/4 and full.
        ClkPortB	: in std_logic;
        RstPortB	: in std_logic;
        EnaPortB	: in std_logic;
        DatOutportB	: out std_logic_vector (31 downto 0)
    );
end component;

component LargeSelfAddrFifo_Tester
	port (
        ClkPortA	: out std_logic;
        RstPortA	: out std_logic;
        EnaPortA	: out std_logic;
        WrePortA	: out std_logic;
        DatInPortA	: out std_logic_vector (31 downto 0);
        FlagE		: in std_logic;		-- Empty flag. Fifo between empty and 1/4.
        FlagEh		: in std_logic;		-- Empty-Half flag. Fifo between 1/4 and half.
        FlagHf		: in std_logic;		-- Half-Full flag. Fifo between half and 3/4.
        FlagF		: in std_logic;		-- Full flag. Fifo between 3/4 and full.
        ClkPortB	: out std_logic;
        RstPortB	: out std_logic;
        EnaPortB	: out std_logic;
        DatOutportB	: in std_logic_vector (31 downto 0)
	);
end component;

begin
-- port mappings.
I0 : LargeSelfAddrFifo
    port map (
        ClkPortA	=> SimClkPortA,
        RstPortA	=> SimRstPortA,
        EnaPortA	=> SimEnaPortA,
        WrePortA	=> SimWrePortA,
        DatInPortA	=> SimDatInPortA,
        FlagE		=> SimFlagE;
        FlagEh		=> SimFlagEh;
        FlagHf		=> SimFlagHf;
        FlagF		=> SimFlagF;
        ClkPortB	=> SimClkPortB,
        RstPortB	=> SimRstPortB,
        EnaPortB	=> SimEnaPortB,
        DatOutportB	=> SimDatOutportB
    );
I1 : LargeSelfAddrFifo_Tester
    port map (
        ClkPortA	=> SimClkPortA,
        RstPortA	=> SimRstPortA,
        EnaPortA	=> SimEnaPortA,
        WrePortA	=> SimWrePortA,
        DatInPortA	=> SimDatInPortA,
        FlagE		=> SimFlagE;
        FlagEh		=> SimFlagEh;
        FlagHf		=> SimFlagHf;
        FlagF		=> SimFlagF;
        ClkPortB	=> SimClkPortB,
        RstPortB	=> SimRstPortB,
        EnaPortB	=> SimEnaPortB,
        DatOutportB	=> SimDatOutportB
    );

end LargeSelfAddrFifo_struct;
