-----------------------------------------------------------------------------------------------------------------------------------------
-- Entity Name:  LargeSelfAddrFifo_Tester
-- File Name:    LargeSelfAddrFifo_Tester.vhd
-- File Path:    E:\Projects\LargeSelfAddrFifo\Vhdl\
-- Project :
--
-- TESTER, DON'T USE THIS FILE FOR COMPILATION !
-- Purpose: 
--
-- Limitations: none
--
-- Authors: Marc Defossez
--
-- Tools: 
--
--  Contact:    e-mail  hotline@xilinx.com        phone   + 1 800 255 7778
--
--  Disclaimer:
--              LIMITED WARRANTY AND DISCLAMER.
--              These designs are provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied, statutory or otherwise, and
--              Xilinx specifically disclaims any implied warranties of merchantability, non-infringement,
--              or fitness for a particular purpose. Xilinx does not warrant that the functions contained
--              in these designs will meet your requirements, or that the operation of these designs will
--              be uninterrupted or error free, or that defects in the designs will be corrected.
--              Furthermore, Xilinx does not warrant or make any representations regarding use or the
--              results of the use of the designs in terms of correctness, accuracy, reliability, or otherwise.
--
--              LIMITATION OF LIABILITY.
--              In no event will Xilinx or its licensors be liable for any loss of data, lost profits, cost or
--              procurement of substitute goods or services, or for any special, incidental, consequential,
--              or indirect damages arising from the use or operation of the designs or accompanying
--              documentation, however caused and on any theory of liability. This limitation will apply
--              even if Xilinx has been advised of the possibility of such damage. This limitation shall
--              apply not-withstanding the failure of the essential purpose of any limited remedies herein.
--
--              Copyright  2002 Xilinx, Inc.
--              All rights reserved
--
-- Revision History:       Created:       08/03/04
--                         Last opened:   Monday,Mar 08 04
--                                        13:14:34
--
----------------------------------------------------------------------------------------------------------------------------------------
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;
use IEEE.std_logic_textio.all;
use std.textio.all;
use IEEE.std_logic_arith.all;

entity LargeSelfAddrFifo_Tester is
    port (
        ClkPortA	: out std_logic;
        RstPortA	: out std_logic;
        EnaPortA	: out std_logic;
        WrePortA	: out std_logic;
        DatInPortA	: out std_logic_vector (31 downto 0);
        FlagE		: in std_logic;		-- Empty flag. Fifo between empty and 1/4.
        FlagEh		: in std_logic;		-- Empty-Half flag. Fifo between 1/4 and half.
        FlagHf		: in std_logic;		-- Half-Full flag. Fifo between half and 3/4.
        FlagF		: in std_logic;		-- Full flag. Fifo between 3/4 and full.
        ClkPortB	: out std_logic;
        RstPortB	: out std_logic;
        EnaPortB	: out std_logic;
        DatOutportB	: in std_logic_vector (31 downto 0) 
    );
end LargeSelfAddrFifo_Tester;

architecture LargeSelfAddrFifo_flow of LargeSelfAddrFifo_Tester is
-- Functions
function str_to_stdlvec(inp: string) return std_logic_vector is
	variable temp: std_logic_vector(inp'range) := (others => 'X');
begin 
	for i in inp'range loop
		if (inp(i) = '1') then
			temp(i) := '1';
		elsif (inp(i) = '0') then
			temp(i) := '0'; 
		end if;
	end loop;
return temp;
end function str_to_stdlvec;

function stdlvec_to_str(inp: std_logic_vector) return string is
	variable temp: string(inp'left+1 downto 1) := (others => 'X');
begin
	for i in inp'reverse_range loop
		if (inp(i) = '1') then
			temp(i+1) := '1';
		elsif (inp(i) = '0') then
			temp(i+1) := '0'; 
		end if;
	end loop;
return temp;
end function stdlvec_to_str;

-- Architecture declarations
constant ClockPeriodA : time := 2.8 ns;
constant ClockPeriodB : time := 10 ns;
signal IntClkA : std_logic;
signal IntClkB : std_logic;

begin

MainProc : process
--file TextFile : text is in "LargeSelfAddrFifoDat.vec"; -- OLD VHDL syntax, ModelSim gives a warning.
file TextFile : text;
variable LineLength : line;
variable DatIn : string(32 downto 1);
begin
	wait for 50 ns;
	RstPortA <= '1';
	RstPortB <= '1';
	wait for 33 ns;
	EnaPortA <= '0';
	EnaPortB <= '0';
	WrePortA <= '1';
	wait for 24 ns;
	RstPortA <= '0';
	RstPortB <= '0';
	wait for 37 ns;
	EnaPortA <= '1';
	wait for 2.5 ns;
	EnaPortB <= '1';
	wait for 8 ns;
--
	FILE_OPEN (TextFile, "E:\Projects\SelfAddressingFifo\Simscripts\LargeSelfAddrFifoDat.vec", READ_MODE);
	ReadCharacters : while not endfile (TextFile) loop
		readline (TextFile, LineLength);
		read (LineLength, DatIn);
		DatInPortA <= str_to_stdlvec(DatIn);
		assert false
		report "Read data in file"
		severity warning;
		wait for 2.5 ns;			-- Data apply time smaller than a clock cycle.
	end loop;
--
	assert false
	report "That's All FOlks !"
	severity warning;
    wait;
end process MainProc;


-- Architecture concurrent statements
-- generate the clock for port A
ClockGenA : process
begin
   IntClkA <= '0';
   wait for ClockPeriodA/2;
   IntClkA <= '1';
   wait for ClockPeriodA/2;
end process;
ClkPortA <= IntClkA;

-- generate the clock for port B
ClockGenB : process
begin
   IntClkB <= '0';
   wait for ClockPeriodB/2;
   IntClkB <= '1';
   wait for ClockPeriodB/2;
end process;
ClkPortB <= IntClkB;

end LargeSelfAddrFifo_flow;
