-----------------------------------------------------------------------------------------------------------------------------------------
-- Entity Name:  AttributeUseSample
-- File Name:    AttributeUseSample.vhd
-- File Path:    E:\Projects\EmifTi\EMIF_V4\Vhdl\
-- Project :
--
-- Purpose: 
--
-- Limitations: none
--
-- Authors: Marc Defossez
--
-- Tools: 
--
--  Contact:    e-mail  hotline@xilinx.com        phone   + 1 800 255 7778
--
--  Disclaimer:
--              LIMITED WARRANTY AND DISCLAIMER.
--              These designs are provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied, statutory or otherwise, and
--              Xilinx specifically disclaims any implied warranties of merchantability, non-infringement,
--              or fitness for a particular purpose. Xilinx does not warrant that the functions contained
--              in these designs will meet your requirements, or that the operation of these designs will
--              be uninterrupted or error free, or that defects in the designs will be corrected.
--              Furthermore, Xilinx does not warrant or make any representations regarding use or the
--              results of the use of the designs in terms of correctness, accuracy, reliability, or otherwise.
--
--              LIMITATION OF LIABILITY.
--              In no event will Xilinx or its licensors be liable for any loss of data, lost profits, cost or
--              procurement of substitute goods or services, or for any special, incidental, consequential,
--              or indirect damages arising from the use or operation of the designs or accompanying
--              documentation, however caused and on any theory of liability. This limitation will apply
--              even if Xilinx has been advised of the possibility of such damage. This limitation shall
--              apply not-withstanding the failure of the essential purpose of any limited remedies herein.
--
--              Copyright  2002 Xilinx, Inc.
--              All rights reserved
--
-- Revision History:       Created:       22/02/05
--                         Last opened:   Tuesday,Feb 22 05
--
----------------------------------------------------------------------------------------------------------------------------------------
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;
-- Simulation libraries
	-- synopsys translate_off
	library UNISIM;
	use UNISIM.all;
	-- synopsys translate_on
-- end simulation libraries

-- Libraries for Synplicity
-- Needed for components as LUT, SRL which get an INIT parameter.
-- When this library is not mentioned Synplify_Pro fails during synthesis of
-- the hardware with an error about the INIT value.
-- library virtex2;
-- use virtex2.components.all;
-- This library is ignored by Mentor Precision.
-- Only a warning is generated.
-- End libraries for Synplicity

entity AttributeUseSample is
    port (
        
    );
end  AttributeUseSample ;

architecture AttributeUseSample_arch of AttributeUseSample  is
----------------------------------------------------------------------------------------------------------------------------------------
-- Component Instantiation
----------------------------------------------------------------------------------------------------------------------------------------
component ISERDES
generic (
	.......................
	............
	.....
    INTERFACE_TYPE	: string	:= "MEMORY";
    IOBDELAY		: string	:= "NONE";
    IOBDELAY_TYPE	: string	:= "DEFAULT";
    IOBDELAY_VALUE	: integer	:= 0;
    NUM_CE			: integer	:= 2;
    SERDES_MODE		: string	:= "MASTER";
    SRVAL_Q1		: bit		:= '0';
    SRVAL_Q2		: bit		:= '0';
    SRVAL_Q3		: bit		:= '0';
    SRVAL_Q4		: bit		:= '0'
    );
port (
    O			: out std_logic;
    Q1			: out std_logic;
	........
	.............
	...................
    SR			: in std_logic
  );
----------------------------------------------------------------------------------------------------------------------------------------
-- Signal, Constants and Attributes Declarations
----------------------------------------------------------------------------------------------------------------------------------------
-- Constants
type TraceMatchVal is array (0 to NumberOfBits-1) of generic;
constant IdelayValue : TraceMatchValue := (
	4,	-- First value
	6,
	2,
	0,
	...
	...		-- Last value
	);
	
-- Signals

-- Attributes

----------------------------------------------------------------------------------------------------------------------------------------
--
begin

...........................
.....................
..............
.......
...
DacIn : for n in 0 to NumberOfBits-1 generate
	TheSerdes : ISERDES
		generic map (
		    BITSLIP_ENABLE	=> FALSE,
		    DATA_RATE		=> "SDR",
		    DATA_WIDTH		=> 4,
		    INIT_Q1			=> '0',
		    INIT_Q2			=> '0',
		    INIT_Q3			=> '0',
		    INIT_Q4			=> '0',
		    INTERFACE_TYPE	=> "MEMORY",
		    IOBDELAY		=> "IFD",		-- The IDELAY is connected to the first FF.
		    IOBDELAY_TYPE	=> "FIXED",
		    IOBDELAY_VALUE	=> IdelayValue, -- Vlue of the IDELAY coming from a list
		    NUM_CE			=> 1,
		    SERDES_MODE		=> "MASTER",
		    SRVAL_Q1		=> '0',
		    SRVAL_Q2		=> '0',
		    SRVAL_Q3		=> '0',
		    SRVAL_Q4		=> '0'
		    )
		port map (
		    O			=> ,
		    Q1			=> ,
		    Q2			=> ,
		    Q3			=> ,
			..........
			...............
			.......................
			...........................
end generate;

end  AttributeUseSample_arch ;