-----------------------------------------------------------------------------------------------------------------------------------------
-- Entity Name:  TestIserdesBufr
-- File Name:    TestIserdesBufr.vhd
-- File Path:    E:\Projects\EmifTi\EMIF_V4\Vhdl\
-- Project :
--
-- Purpose: 
--
-- Limitations: none
--
-- Authors: Marc Defossez
--
-- Tools: 
--
--  Contact:    e-mail  hotline@xilinx.com        phone   + 1 800 255 7778
--
--  Disclaimer:
--              LIMITED WARRANTY AND DISCLAIMER.
--              These designs are provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied, statutory or otherwise, and
--              Xilinx specifically disclaims any implied warranties of merchantability, non-infringement,
--              or fitness for a particular purpose. Xilinx does not warrant that the functions contained
--              in these designs will meet your requirements, or that the operation of these designs will
--              be uninterrupted or error free, or that defects in the designs will be corrected.
--              Furthermore, Xilinx does not warrant or make any representations regarding use or the
--              results of the use of the designs in terms of correctness, accuracy, reliability, or otherwise.
--
--              LIMITATION OF LIABILITY.
--              In no event will Xilinx or its licensors be liable for any loss of data, lost profits, cost or
--              procurement of substitute goods or services, or for any special, incidental, consequential,
--              or indirect damages arising from the use or operation of the designs or accompanying
--              documentation, however caused and on any theory of liability. This limitation will apply
--              even if Xilinx has been advised of the possibility of such damage. This limitation shall
--              apply not-withstanding the failure of the essential purpose of any limited remedies herein.
--
--              Copyright  2002 Xilinx, Inc.
--              All rights reserved
--
-- Revision History:       Created:       21/02/05
--                         Last opened:   Monday,Feb 21 05
--
----------------------------------------------------------------------------------------------------------------------------------------
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;
-- Simulation libraries
	-- synopsys translate_off
	library UNISIM;
	use UNISIM.all;
	-- synopsys translate_on
-- end simulation libraries

-- Libraries for Synplicity
-- Needed for components as LUT, SRL which get an INIT parameter.
-- When this library is not mentioned Synplify_Pro fails during synthesis of
-- the hardware with an error about the INIT value.
-- library virtex2;
-- use virtex2.components.all;
-- This library is ignored by Mentor Precision.
-- Only a warning is generated.
-- End libraries for Synplicity

entity TestIserdesBufr is
    port (
        Rst : in std_logic;
        Clk : in std_logic;
        Cen : in std_logic;
        Din : in std_logic;
        Dout : out std_logic_vector (3 downto 0)
    );
end  TestIserdesBufr ;

architecture TestIserdesBufr_arch of TestIserdesBufr  is
----------------------------------------------------------------------------------------------------------------------------------------
-- Component Instantiation
----------------------------------------------------------------------------------------------------------------------------------------
component IBUF_LVCMOS33	port (O : out std_logic; I : in  std_logic); end component;
component OBUF_LVCMOS33_S_12	port (O : out std_logic; I : in std_logic); end component;
  
component BUFIO	port (O : out std_logic; I : in  std_logic); end component;

component BUFR
	generic	(BUFR_DIVIDE   : string := "BYPASS");
	port 	(O : out std_logic; CE, CLR, I : in  std_logic); end component;

component FDP	port (Q : out std_logic; D, C, PRE : in std_logic); end component;
component FDC	port (Q : out std_logic; D, C, CLR : in std_logic); end component;

component IDELAY
generic(
    IOBDELAY_TYPE  : string := "DEFAULT";
    IOBDELAY_VALUE : integer := 0
    );
port(
    O      : out std_ulogic;
    C      : in  std_ulogic;
    CE     : in  std_ulogic;
    I      : in  std_ulogic;
    INC    : in  std_ulogic;
    RST    : in  std_ulogic
    );
end component;
  
component ISERDES
generic (
    BITSLIP_ENABLE	: boolean	:= false;
    DATA_RATE		: string	:= "DDR";
    DATA_WIDTH		: integer	:= 4;
    INIT_Q1			: bit		:= '0';
    INIT_Q2			: bit		:= '0';
    INIT_Q3			: bit		:= '0';
    INIT_Q4			: bit		:= '0';
    INTERFACE_TYPE	: string	:= "MEMORY";
    IOBDELAY		: string	:= "NONE";
    IOBDELAY_TYPE	: string	:= "DEFAULT";
    IOBDELAY_VALUE	: integer	:= 0;
    NUM_CE			: integer	:= 2;
    SERDES_MODE		: string	:= "MASTER";
    SRVAL_Q1		: bit		:= '0';
    SRVAL_Q2		: bit		:= '0';
    SRVAL_Q3		: bit		:= '0';
    SRVAL_Q4		: bit		:= '0'
    );
port (
    O			: out std_logic;
    Q1			: out std_logic;
    Q2			: out std_logic;
    Q3			: out std_logic;
    Q4			: out std_logic;
    Q5			: out std_logic;
    Q6			: out std_logic;
    SHIFTOUT1	: out std_logic;
    SHIFTOUT2	: out std_logic;
    BITSLIP		: in std_logic;
    CE1			: in std_logic;
    CE2			: in std_logic;
    CLK			: in std_logic;
    CLKDIV		: in std_logic;
    D			: in std_logic;
    DLYCE		: in std_logic;
    DLYINC		: in std_logic;
    DLYRST		: in std_logic;
    OCLK		: in std_logic;
    REV			: in std_logic;
    SHIFTIN1	: in std_logic;
    SHIFTIN2	: in std_logic;
    SR			: in std_logic
  );
end component;
----------------------------------------------------------------------------------------------------------------------------------------
-- Signal, Constants and Attributes Declarations
----------------------------------------------------------------------------------------------------------------------------------------
-- Constants

-- Signals
signal ClkToBufIo	: std_logic;
signal ClkToIdlay	: std_logic;
signal IdlayToBufIo	: std_logic;
signal IntClk		: std_logic;
signal IntClkNot	: std_logic;
signal IntClkDiv	: std_logic;

signal IntDatIn : std_logic;
signal IntDatOut : std_logic_vector (3 downto 0);

signal IntRst : std_logic;
signal IntCen : std_logic;
signal IntCenNot : std_logic;
signal IntCntOut : std_logic_vector (1 downto 0);
signal IntCntCe : std_logic;
signal IntCntDir : std_logic;
signal IntTcHigh : std_logic;
signal IntTcLow : std_logic;
signal IntLoadIserdes : std_logic;
signal IntCntDirNot : std_logic;
signal IntSrRegLd : std_logic;
signal IntSrRegIn : std_logic_vector (3 downto 0);
signal IntSrRegOut : std_logic_vector (3 downto 0);

signal Low : std_logic := '0';
signal High : std_logic := '1';
-- Attributes

----------------------------------------------------------------------------------------------------------------------------------------
--
begin

TheRst : IBUF_LVCMOS33	port map (I => Rst, O => IntRst);
TheCen : IBUF_LVCMOS33	port map (I => Cen, O => IntCen);
TheClk : IBUF_LVCMOS33	port map (I => Clk, O => ClkToIdlay);
TheClkDelay : IDELAY
	generic map (
    	IOBDELAY_TYPE  => "FIXED",
    	IOBDELAY_VALUE => 0
    )
	port map (
    O      => IdlayToBufIo,
    C      => Low,
    CE     => Low,
    I      => ClkToIdlay,
    INC    => Low,
    RST    => Low
    );
TheBufIo : BUFIO port map (I => IdlayToBufIo, O => IntClk);
TheBufrOne : BUFR
	generic map (BUFR_DIVIDE => "BYPASS")
	port map (	
		I	=> IntClk,
		CE	=> High,
		CLR	=> Low,
		O	=> IntClkDiv
	);
	
TheDatIn : IBUF_LVCMOS33	port map (I => Din, O => IntDatIn);


TheCenCtrl : process (IntClkDiv, IntRst)
begin
	if (IntRst = '1') then
		IntCntCe <= '0';
	elsif (IntClkDiv'event and IntClkDiv = '0') then			-- Clocked on negative edge.
		IntCntCe <= not IntCen; 								-- Cen is active low.
	end if;
end process;
IntCenNot <= not IntCen;

TheCnt : process (IntClkDiv, IntRst, IntCntCe, IntCntDir)
begin
	if (IntRst = '1') then
		IntCntOut <= (Others => '0');
	elsif (IntClkDiv'event and IntClkDiv = '1') then
		if (IntCntCe = '1') then
			IntCntOut <= IntCntOut + 1;
		end if;
	end if;
end process;
IntTcHigh <= '1' when (IntCntOut = "11" and IntCntDir = '1') else '0';	-- Upper terminal count


IntLoadIserdes <= IntTcHigh;
			
TheDirFf : process (IntClkDiv, IntRst)
begin
	if (IntRst = '1') then
		IntCntDirNot <= '0';
	elsif (IntClkDiv'event and IntClkDiv = '0') then	-- Clocked on falling edge
		if (IntTcHigh = '1') then
			IntCntDirNot <= not IntCntDirNot;			-- When terminal count switch direction.
		end if;
	end if;
end process;
IntCntdir <= not IntCntDirNot;

--
TheSerdes : ISERDES
	generic map (
	    BITSLIP_ENABLE	=> FALSE,
	    DATA_RATE		=> "SDR",
	    DATA_WIDTH		=> 4,
	    INIT_Q1			=> '0',
	    INIT_Q2			=> '0',
	    INIT_Q3			=> '0',
	    INIT_Q4			=> '0',
	    INTERFACE_TYPE	=> "MEMORY",
	    IOBDELAY		=> "NONE",
	    IOBDELAY_TYPE	=> "DEFAULT",
	    IOBDELAY_VALUE	=> 0,
	    NUM_CE			=> 1,
	    SERDES_MODE		=> "MASTER",
	    SRVAL_Q1		=> '0',
	    SRVAL_Q2		=> '0',
	    SRVAL_Q3		=> '0',
	    SRVAL_Q4		=> '0'
	    )
	port map (
	    O			=> open,
	    Q1			=> IntSrRegIn(3),
	    Q2			=> IntSrRegIn(2),
	    Q3			=> IntSrRegIn(1),
	    Q4			=> IntSrRegIn(0),
	    Q5			=> open,
	    Q6			=> open,
	    SHIFTOUT1	=> open,
	    SHIFTOUT2	=> open,
	    BITSLIP		=> Low,
	    CE1			=> IntCenNot,
	    CE2			=> Low,
	    CLK			=> IntClk,
	    CLKDIV		=> IntLoadIserdes,
	    D			=> IntDatIn,
	    DLYCE		=> Low,
	    DLYINC		=> Low,
	    DLYRST		=> Low,
	    OCLK		=> Low,
	    REV			=> Low,
	    SHIFTIN1	=> Low,
	    SHIFTIN2	=> Low,
	    SR			=> IntRst
	);
--

IntSrRegLd <= '1' when (IntTcHigh = '1') else '0'; -- Load the shift register when TC.

TheSrReg : process (IntClkDiv, IntRst, IntSrRegLd)
begin
	if (IntRst = '1') then
		IntSrRegOut <= (others => '0');
	elsif (IntClkDiv'event and IntClkDiv = '1') then
		if (IntSrRegLd = '1') then						-- Load the shift register
			IntSrRegOut <= IntSrRegIn;
		elsif (IntSrRegLd = '0') then					-- Shift the register from 3 downto 0, filling with '0';
			IntSrRegOut <= '0' & IntSrRegOut (3 downto 1);
		end if;
	end if;
end process;

TheDatOut : for n in 3 downto 0 generate
	OneOut : OBUF_LVCMOS33_S_12
		port map (
			I => IntSrRegOut(n),
			O => Dout(n)
		);
end generate;

end  TestIserdesBufr_arch ;